#include "server.h"
#include "utl.h"


server::server( const short port)
{
	memset( &server_addr, 0, sizeof(server_addr) );

	server_addr.sin_family = AF_INET;
	server_addr.sin_port   = htons(port);
	server_addr.sin_addr.s_addr = htonl( INADDR_ANY );
}

server::~server()
{
	close(sock_serv);
}

int server::initServer()
{
	sock_serv = socket(AF_INET, SOCK_STREAM, 0);
	if(sock_serv < 0){
		perror("socket error!\n");
		return -1;
	}

	int on = 1;
	setsockopt( sock_serv, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on) );

	int flag = bind(sock_serv, (struct sockaddr*)&server_addr, sizeof(server_addr));
	if(flag < 0){
		perror("bind error!\n");
		close(sock_serv);
		return -1;
	}

	return 0;
}

void pthread_work(struct argc *argc2)
{
	int flag;
	struct argc argc1;
	argc1.sock_clt = argc2->sock_clt;
	argc1.sock_serv = argc2->sock_serv;
	printf("%d,%d\n",argc1.sock_clt,argc1.sock_serv);
	char buffer[1024];
	strcpy(buffer, "this is server! welcome!\n");
	//send(sock_client, buffer, 1024, 0);
	send(argc1.sock_clt, buffer, 1024, 0);

	bzero(buffer,sizeof(buffer));
	//flag = recv(sock_client, buffer, 1024, 0);
	flag = recv(argc1.sock_clt, buffer, 1024, 0);
	if(flag < 0){
		perror("recv error!\n");
		close(argc1.sock_serv);
		return;
	}
	printf("recv : %s\n",buffer);

	while(1){
		bzero(buffer,sizeof(buffer));
		//flag = recv(sock_client, buffer, 1024, 0);
		recv(argc1.sock_clt, buffer, 1024, 0);
		if(flag < 0){
			perror("recv error!\n");
			close(argc1.sock_serv);
			return;
		}
		printf("i have recv buffer\n");
		printf("recv : %s\n",buffer);
		if(strcmp(buffer,"quit") == 0){
			printf("quit!!!\n");
			break;
		}
	}
	close(argc1.sock_serv);
	pthread_exit(0);
}

void server::startListen()
{
	int flag = listen(sock_serv, 5);
	if(flag < 0){
		perror("listen error!\n");
		close(sock_serv);
		return;
	}

	//char buffer[1024];

	while(1){

		//bzero(buffer,sizeof(buffer));

		struct sockaddr_in client_addr;
		int size = sizeof(client_addr);
		int sock_client = accept(sock_serv, (struct sockaddr*)(&client_addr), (unsigned int*)(&size));
		if(sock_client < 0){
			perror("accept error!\n");
			continue;
		}

		printf("%d\n",sock_client);

		argc arg1;
		arg1.sock_serv = sock_serv;
		arg1.sock_clt  = sock_client;

		pthread_t new_thread;
		flag = pthread_create(&new_thread,NULL,(void*(*)(void*))(&pthread_work),(void*)(&arg1));
		if(flag != 0){
			perror("thread creation failed!\n");
			continue;
		}
		/*
		strcpy(buffer, "this is server! welcome!\n");
		send(sock_client, buffer, 1024, 0);

		bzero(buffer,sizeof(buffer));
		flag = recv(sock_client, buffer, 1024, 0);
		if(flag < 0){
			perror("recv error!\n");
			close(sock_serv);
			return;
		}
		printf("recv : %s\n",buffer);

		while(1){
			bzero(buffer,sizeof(buffer));
			flag = recv(sock_client, buffer, 1024, 0);
			if(flag < 0){
				perror("recv error!\n");
				close(sock_serv);
				return;
			}
			printf("i have recv buffer\n");
			printf("recv : %s\n",buffer);
			if(strcmp(buffer,"quit") == 0){
				printf("quit!!!\n");
				break;
			}
		}
		*/
		/*
		time_t current = time(0);
		send( sock_client, (const char*)current, sizeof(time_t), 0 );

		printf( "your connection is ok\n");
		printf( "now close your connection\n");
		close( sock_client );
		*/
	}
}
